---
apiVersion: v1
kind: Namespace
metadata:
  name: shifts
---
apiVersion: apps/v1
kind: Deployment
metadata:
  labels:
    app: shifts
  name: shifts
  namespace: shifts
spec:
  replicas: 2
  selector:
    matchLabels:
      app: shifts
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxUnavailable: 1
  template:
    metadata:
      labels:
        app: shifts
    spec:
      containers:
        - image: kennethreitz/httpbin
          ports:
            - containerPort: 80
          name: shifts
          readinessProbe:
            failureThreshold: 30
            httpGet:
              path: /get
              port: 80
              scheme: HTTP
            initialDelaySeconds: 1
            periodSeconds: 2
            successThreshold: 1
            timeoutSeconds: 3
---
apiVersion: v1
kind: Service
metadata:
  labels:
    app: shifts
  name: shifts
  namespace: shifts
spec:
  ports:
    - port: 80
      targetPort: 80
  selector:
    app: shifts
---
apiVersion: autoscaling/v2
kind: HorizontalPodAutoscaler
metadata:
  name: shifts
  namespace: shifts
spec:
  scaleTargetRef:
    apiVersion: apps/v1
    kind: Deployment
    name: shifts
  minReplicas: 1
  maxReplicas: 5
  metrics:
    - type: Resource
      resource:
        name: cpu
        target:
          type: Utilization
          averageUtilization: 70
---
apiVersion: policy/v1
kind: PodDisruptionBudget
metadata:
  name: shifts
  namespace: shifts
spec:
  minAvailable: 50%
  selector:
    matchLabels:
      app: shifts
